## rustc 1.65.0+dfsg0ubuntu1~llvm2

=== src/llvm-project/clang-tools-extra/include-cleaner/CMakeLists.txt ===
add_subdirectory(lib)
if(CLANG_INCLUDE_TESTS)
  add_subdirectory(test)
  add_subdirectory(unittests)
endif()
