=== src/llvm-project/clang-tools-extra/pseudo/CMakeLists.txt ===
include_directories(include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
add_subdirectory(include)
add_subdirectory(gen)
add_subdirectory(lib)
add_subdirectory(tool)
add_subdirectory(fuzzer)
add_subdirectory(benchmarks)
if(CLANG_INCLUDE_TESTS)
  add_subdirectory(unittests)
  add_subdirectory(test)
endif()
