=== debian/changelog ===
rustc (1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.18.04) bionic; urgency=medium

  * Update the vendored LLVM 15 to the latest bugfix release to fix ppc64el
    build.
  * Cherry-pick upstream patch to fix FTBFS on ppc64el and arm64

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 25 Jan 2023 18:02:05 +0100

rustc (1.65.0+dfsg0ubuntu1~llvm-0ubuntu0.18.04) bionic; urgency=medium

  * Backport to bionic (LP: #2000839)
  * Comment out vendored source tracking
  * Re-enable embedded LLVM:
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
    - Adjust debian/watch to include +llvm in upstream version.
    - Remove the rust-all dependency on llvm-14 due to vendoring
  * Revert debhelper compat 13 bump back to 11
  * d/control: Build-depend on cmake-mozilla

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 20 Jan 2023 18:30:55 +0100

rustc (1.65.0+dfsg0ubuntu1-0ubuntu2) lunar; urgency=medium

  * d/control: actually bump the version number in the package names

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 20 Jan 2023 16:18:38 +0100

rustc (1.65.0+dfsg0ubuntu1-0ubuntu1) lunar; urgency=medium

  [ Simon Chopin ]
  * New upstream release (LP: #2000839)
  * d/p/u-arm-compiler-builtins-add-sync-builtin-fallbacks.patch:
    Dropped, applied upstream
  * Update vendored deps field

  [ Fabian Grünbichler ]
  * add overrides for rust-analyzer test data
  * update d/copyright
  * cherry-pick fix for compiletest with rpath=false
  * Update Files-Excluded for new upstream version 1.65.0
  * Update early-stage patches for 1.65.0+dfsg1


 -- Simon Chopin <schopin@ubuntu.com>  Fri, 20 Jan 2023 10:43:28 +0100
