## rustc 1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.18.04+9.0trisquel1

=== debian/changelog ===
rustc (1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.18.04+9.0trisquel1) etiona-backports; urgency=medium

  * Import as dependency of newer abrowser deb dependencies.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 25 Jan 2023 18:40:11 +0000
