=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: rustc
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  Ximin Luo <infinity0@debian.org>,
@@ -140,4 +140,3 @@
  maintaining boundaries - both abstract and operational - that
  preserve large-system integrity, availability and concurrency.
  .
- It supports a mixture of imperative procedural, concurrent actor,
