## rustc 1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.20.04+10.0trisquel1

=== debian/changelog ===
rustc (1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.20.04+10.0trisquel1) nabia-backports; urgency=medium

  * Import as dependency of newer abrowser deb dependencies.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 25 Jan 2023 18:40:36 +0000

rustc (1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.20.04) focal; urgency=medium

  * Update the vendored LLVM 15 to the latest bugfix release to fix ppc64el
    build.
  * Cherry-pick upstream patch to fix FTBFS on ppc64el and arm64

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 25 Jan 2023 18:02:05 +0100

rustc (1.65.0+dfsg0ubuntu1~llvm-0ubuntu0.20.04) focal; urgency=medium

  * Backport to focal (LP: #2000839)
  * Comment out vendored source tracking
  * Re-enable embedded LLVM:
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
    - Adjust debian/watch to include +llvm in upstream version.
    - Remove the rust-all dependency on llvm-14 due to vendoring
  * Revert debhelper compat 13 bump back to 12

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 20 Jan 2023 18:23:46 +0100
