=== debian/control ===
--- 
+++ 
@@ -10,14 +10,14 @@
 # :native annotations are to support cross-compiling, see README.Debian
 Build-Depends:
  debhelper (>= 9),
- debhelper-compat (= 11),
+ debhelper-compat (= 12),
 # dh-cargo (>= 28ubuntu1~),
  dpkg-dev (>= 1.17.14),
  python3:native,
  cargo:native (>= 0.60.0)      <!pkg.rustc.dlstage0>,
  rustc:native (>= 1.64.0+dfsg) <!pkg.rustc.dlstage0>,
  rustc:native (<= 1.65.0++)    <!pkg.rustc.dlstage0>,
- cmake-mozilla,
+ cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
  pkg-config,
 # this is sometimes needed by rustc_llvm
